//+------------------------------------------------------------------+
//|                                            SeriesAnalysisLib.mqh |
//|                            Copyright  2007, Alexander Enchevich |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Alexander Enchevich"

#import "SeriesAnalysisLib.ex4"

//+------------------------------------------------------------------+
// Return Value: the total number of times that the samples in 
// arrFastSeries cross those in arrSlowSeries.
// Params:
//	iNumCrossesUp - upon return will contain number of times that Fast 
//					series aproaches Slow series from below and crosses it.
//	iNumCrossesDown - upon return will contain number of times that Fast 
//					series aproaches Slow series from above and crosses it.
//	iTickBackStart - analyze series starting from this tick (current tick is 0)
//	iTickBackEnd - analyze series up to this tick (current tick is 0)
//	arrFastSeries[] - samples for series 1
//	arrSlowSeries[] - samples for series 2
//
// NOTE:the function will not 0 iNumCrossesUp and iNumCrossesDown. If you
// 		want them zeroed - do it urself b4 calling this function.
//
int CountNumCrosses(int& iNumCrossesUp,
					int& iNumCrossesDown,
					int iTickBackStart, 
					int iTickBackEnd, 
					double arrFastSeries[], 
					double arrSlowSeries[] );
//+------------------------------------------------------------------+
// was the last cross of the series a cross Down, i.e FastSeries
// approaches SlowSeries from above and crosses it downwards
bool IsCrossDown(int iTickBackStart,
				int iTickBackEnd, 
				double arrFastSeries[], 
				double arrSlowSeries[] );
//+------------------------------------------------------------------+
// was the last cross of the series a cross up, i.e FastSeries
// approaches SlowSeries from below and crosses it upwards
bool IsCrossUp(	int iTickBackStart,
				int iTickBackEnd, 
				double arrFastSeries[], 
				double arrSlowSeries[] );
//+------------------------------------------------------------------+
// Get the index of the first pair from the 2 series which lie past 
// the cross. 
// TODO !!!!!!!!!!! :
// test and verify whether this function will return 0 if the 
// first pair of samples in the 2 series have the same values.
int GetFirstCrossIndex(	int iTickBackStart,
						double arrFastSeries[], 
						double arrSlowSeries[] );
//+------------------------------------------------------------------+
int GetFirstCrossUpIndex(	int iTickBackStart,
							double arrFastSeries[], 
							double arrSlowSeries[] );
//+------------------------------------------------------------------+
int GetFirstCrossDownIndex(	int iTickBackStart,
							double arrFastSeries[], 
							double arrSlowSeries[] );
//+------------------------------------------------------------------+
double  SeriesConvergence (	int iTickBackStart,
							int iTickBackEnd, 
							double arrFastSeries[], 
							double arrSlowSeries[] );
//+------------------------------------------------------------------+
// what is the average absolute difference betwen the values of the 2 series
double SeriesAvgDelta( 	int iTickBackStart,
						int iTickBackEnd, 
						double arrFastSeries[], 
						double arrSlowSeries[] );
//+------------------------------------------------------------------+

