//+------------------------------------------------------------------+
//|                                                   TradingLib.mq4 |
//|                            Copyright  2007, Alexander Enchevich |
//|                                                                  |
//| Note: Depends on CommonLib.                                      |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Alexander Enchevich"
#property link      ""

#import "TradingLib.ex4"

//+------------------------------------------------------------------+
bool IsEmptyPosition(int iMagicNumber);
//+------------------------------------------------------------------+
bool IsBuyPosition(int & iTicket, int iMagicNumber);
//+------------------------------------------------------------------+
bool IsSellPosition(int & iTicket, int iMagicNumber);
//+------------------------------------------------------------------+
// Calculates the optimal number of lots, given a max margin to use 
// and considering previous consecutive losses
double LotsOptimized(double fUseableMargin);
//+------------------------------------------------------------------+
// iOrderType is one of OP_... constants or -1 to close all of our
// positions (with matching MagicNumber).
void CloseAllPositions( int iOrderType, 
						int iMagicNumber, 
						double fPreferredClosePrice,
						int iSlippage, 
						color iColor );
//+------------------------------------------------------------------+
// iOrderType is one of OP_BUY or OP_SELL
// fLots will be normalized to 4, so for JPY normalize it to 2 yourself
// Color or arrow will be Blue for BUY and Red for Sell
// Returns:	the ticket or - on error (will also issue and Alert with 
//			the errno on error).
int OpenAtMarket (  int iOrderType,
					double fLots,
					double fPrice,
					int iSlippage, 
					int iMagicNumber );
//+------------------------------------------------------------------+

